
// rev 06-09-2017
extern sfr sbit DHT22_Pin;
extern sfr sbit DHT22_Pin_Out;
extern sfr sbit DHT22_Pin_Direction;
unsigned short DHT22Check, T_byte1, T_byte2, RH_byte1, RH_byte2, DHT22_Sum;
unsigned long DHT22_full;


unsigned char DHT22_Read_Byte(void)
{  char i,j;
     for(j = 0; j < 8; j++)
     {
       while(!DHT22_Pin);
       Delay_us(30);
       if(DHT22_Pin == 0)
           i&= ~(1<<(7 - j));
           else
           {
              i|= (1 << (7 - j));
              while(DHT22_Pin);
           }
     }
     return(i);
}     

unsigned long DHT22_Read_All_Data()
{
 DHT22_Pin_Direction = 0;
  DHT22_Pin_Out = 0;
  Delay_ms(20);
 DHT22_Pin_Out = 1;
  Delay_us(40);
  DHT22_Pin_Direction = 1;
 DHT22Check = 0;
 Delay_us(20);
 if (DHT22_Pin == 0)
  { 
  Delay_us(80);
  if (DHT22_Pin == 1)   DHT22Check = 1;
  Delay_us(40);
  }
  if (DHT22Check == 1)
  {
     RH_byte1 = DHT22_Read_Byte;
     RH_byte2 = DHT22_Read_Byte;
     T_byte1 = DHT22_Read_Byte;
     T_byte2 = DHT22_Read_Byte;
     DHT22_Sum = DHT22_Read_Byte;
     if(DHT22_Sum == ((RH_byte1+RH_byte2+T_byte1+T_byte2) & 0XFF))
       {
       DHT22_full = RH_byte1;
       DHT22_full = (DHT22_full << 8) | RH_byte2;
       DHT22_full = (DHT22_full << 8) | T_byte1;
       DHT22_full = (DHT22_full << 8) | T_byte2;
       }
      else
      {
      DHT22_full = 0x58585858;
      }
   }
  else 
  {
  DHT22_full = 0x63636363;
  }
 return DHT22_full;
}

